/*----- PROTECTED REGION ID(SIKO_MA505.h) ENABLED START -----*/
//=============================================================================
//
// file :        SIKO_MA505.h
//
// description : Include for the SIKO_MA505 class.
//
// project :     SIKO MA505 Magnetic Encoder Display.
//
// $Author: borghes $
//
// $Revision: 1.1.1.1 $
// $Date: 2013-12-24 15:09:38 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/sikoma505/src/SIKO_MA505.h,v $
// $Log: SIKO_MA505.h,v $
// Revision 1.1.1.1  2013-12-24 15:09:38  borghes
// SIKO MA505 encoder display
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef SIKO_MA505_H
#define SIKO_MA505_H


#include <tango.h>

#define SL_NCHAR      1

#define READ_POS_CMD	0x16
#define READ_RESOL_CMD	0x1C

/*----- PROTECTED REGION END -----*/


/**
 *	SIKO_MA505 class Description:
 *	SIKO MA505 Magnetic Encoder Display, SIKONETZ3 RS485.
 *	
 */

namespace SIKO_MA505_ns
{
	/*----- PROTECTED REGION ID(SIKO_MA505::Additional Class Declarations) ENABLED START -----*/

		//		Additional Class Declarations

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::Additional Class Declarations


class SIKO_MA505 : public Tango::Device_4Impl
{


	/*----- PROTECTED REGION ID(SIKO_MA505::Data Members) ENABLED START -----*/

	//		Add your own data members

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::Data Members


//	Device property data members
public:		//	Serial_devicename:	TANGO Serial communication device name
	string	serial_devicename;
	//	Address:	RS485 device address
	Tango::DevShort	address;
	//	Resolution:	Positions after the comma
	Tango::DevShort	resolution;
	
//	Attribute data members
public:
	Tango::DevDouble	*attr_Position_read;



//	Constructors and destructors
public:
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	SIKO_MA505(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	SIKO_MA505(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	SIKO_MA505(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The object destructor.
	 */	
	~SIKO_MA505() {delete_device();};



//	Miscellaneous methods
public:
	/**
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/**
	 *	Initialize the device
	 */
	virtual void init_device();
	/**
	 *	Read the device properties from database
	 */
	 void get_device_property();
	/**
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	/**
	 *	Method      : SIKO_MA505::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	virtual void read_attr_hardware(vector<long> &attr_list);


	/**
	 *	Position attribute related methods.
	 *	Description: Readout position value
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_Position(Tango::Attribute &attr);
	virtual bool is_Position_allowed(Tango::AttReqType type);



	/**
	 *	Method      : SIKO_MA505::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
		void add_dynamic_attributes();

//	Command related methods
public: 




	/*----- PROTECTED REGION ID(SIKO_MA505::Additional Method prototypes) ENABLED START -----*/

	//	Additional Method prototypes
	
	Tango::DeviceProxy *serial_device;
	bool get_serial_connection();
	void close_connection(Tango::DeviceProxy *);
	bool check_connection(Tango::DeviceProxy *);
	
	short write_read(int cmd_id);
	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::Additional Method prototypes

};

	/*----- PROTECTED REGION ID(SIKO_MA505::Additional Classes Definitions) ENABLED START -----*/

	//	Additional Classes definitions

	/*----- PROTECTED REGION END -----*/	//	SIKO_MA505::Additional Classes Definitions

} //	namespace

#endif	//	SIKO_MA505_H
